'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-AtomImage';
var BASE_CLASS_FIGURE = BASE_CLASS + '-figure';
var CLASS_PLACEHOLDER = BASE_CLASS_FIGURE + '--placeholder';
var CLASS_SKELETON = BASE_CLASS_FIGURE + '--skeleton';
var CLASS_IMAGE = BASE_CLASS + '-image';
var CLASS_SPINNER = BASE_CLASS + '-spinner';
var CLASS_ERROR = BASE_CLASS + '-error';

var Error = function Error(_ref // eslint-disable-line react/prop-types
) {
  var className = _ref.className,
      Icon = _ref.icon,
      text = _ref.text;
  return _react2.default.createElement(
    'div',
    { className: className },
    Icon && _react2.default.createElement(Icon, null),
    _react2.default.createElement(
      'p',
      null,
      text
    )
  );
};

var AtomImage = function (_Component) {
  (0, _inherits3.default)(AtomImage, _Component);

  function AtomImage() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomImage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = AtomImage.__proto__ || (0, _getPrototypeOf2.default)(AtomImage)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      loading: true,
      error: false
    }, _this.handleLoad = function () {
      var onLoad = _this.props.onLoad;

      _this.setState({ loading: false });
      onLoad && onLoad();
    }, _this.handleError = function () {
      var onError = _this.props.onError;

      _this.setState({
        error: true,
        loading: false
      });
      onError && onError();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomImage, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          placeholder = _props.placeholder,
          skeleton = _props.skeleton,
          bgStyles = _props.bgStyles,
          Spinner = _props.spinner,
          errorIcon = _props.errorIcon,
          errorText = _props.errorText,
          onError = _props.onError,
          onLoad = _props.onLoad,
          imgProps = (0, _objectWithoutProperties3.default)(_props, ['placeholder', 'skeleton', 'bgStyles', 'spinner', 'errorIcon', 'errorText', 'onError', 'onLoad']);
      var _state = this.state,
          loading = _state.loading,
          error = _state.error;


      var figureStyles = {
        backgroundImage: 'url(' + (placeholder || skeleton) + ')'
      };

      return _react2.default.createElement(
        'div',
        { className: this.classNames },
        _react2.default.createElement(
          'figure',
          {
            className: this.classNamesFigure,
            style: !error && (placeholder || skeleton) ? figureStyles : {}
          },
          _react2.default.createElement('img', (0, _extends3.default)({
            className: CLASS_IMAGE,
            onLoad: this.handleLoad,
            onError: this.handleError
          }, imgProps))
        ),
        !error && loading && Spinner && _react2.default.createElement(Spinner, { className: CLASS_SPINNER }),
        error && _react2.default.createElement(Error, { className: CLASS_ERROR, icon: errorIcon, text: errorText })
      );
    }
  }, {
    key: 'classNames',
    get: function get() {
      var _state2 = this.state,
          loading = _state2.loading,
          error = _state2.error;

      return (0, _classnames2.default)(BASE_CLASS, 'is-' + (loading ? 'loading' : 'loaded'), error && 'is-error');
    }
  }, {
    key: 'classNamesFigure',
    get: function get() {
      var _props2 = this.props,
          placeholder = _props2.placeholder,
          skeleton = _props2.skeleton;

      return (0, _classnames2.default)(BASE_CLASS_FIGURE, placeholder && CLASS_PLACEHOLDER, skeleton && CLASS_SKELETON);
    }
  }]);
  return AtomImage;
}(_react.Component);

AtomImage.displayName = 'AtomImage';
AtomImage.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? (0, _extends3.default)({
  /** Image url or base64 */
  src: _propTypes2.default.string.isRequired,

  /** Description of the image */
  alt: _propTypes2.default.string.isRequired,

  /** Image displayed (blurred) while the final image is being loaded */
  placeholder: _propTypes2.default.string,

  /** Image (wireframe, skeleton) displayed (not blurred) while the final image is being loaded */
  skeleton: _propTypes2.default.string,

  /** Spinner (component) displayed while the final image is being loaded */
  spinner: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),

  /** Icon (component) to be displayed in an Error Box when the image cannot be loaded */
  errorIcon: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),

  /** Text to be displayed in an Error Box when the image cannot be loaded */
  errorText: _propTypes2.default.string,

  /** Function to be called when the image cannot be loaded  */
  onError: _propTypes2.default.func,

  /** Function to be called when the image completed its loading  */
  onLoad: _propTypes2.default.func

}, _types.htmlImgProps) : {} : {};

exports.default = AtomImage;